(* fichier principal *)
(* lecture dans un buffer lexical *)
(* ic est un descripteur de fichier d'entre'e *)

open Lexer
open Parser
open Ml2clos
open Compile
open Emit

exception Error

let read_def lexbuf =
  try
    declaration_list token lexbuf
  with
    Lexical_error(pos1, pos2) ->
      raise Error
  | Parsing.Parse_error ->
      raise Error

(* on verifie le suffixe du fichier *)
let check_suffix file =
  if not (Filename.check_suffix file ".mml")
  then raise (Arg.Bad ("Je ne sais pas quoi faire du fichier " ^ file))

let main file  =
  (* on verifie le suffixe *)
  check_suffix file;
  (* ouverture du fichier *)
  let ic = open_in file in
  let oc = open_out (file ^ ".o") in
  (* on prepare l'affichage du source en cas d'erreur *)
  (* initialise_location file ic;*)
  (* analyseur syntaxique *)
  let lexbuf = Lexing.from_channel ic in
  (* on ne fait rien ici *)
  try
    let d_list = read_def lexbuf in
    let d_list = names d_list in
    let d_list = clos d_list in
    let d_list = compile d_list in
    write_file (file ^ ".o") d_list
  with
    _ -> close_in ic;exit 1;;

(* le point d'entree principal *)
let errmsg = "Aucune option pour le moment"

let main () =
  try
    Arg.parse []
      main
      errmsg;
  with
    _ -> exit 2
;;

Printexc.catch main (); 
exit 0;;

(*
#load "syntaxe_abstraite.cmo";;
#load "cmm.cmo";;
#load "vars.cmo";;
#load "ml2clos.cmo";;
#load "lexer.cmo";;
#load "parser.cmo";;
#load "compile.cmo";;
#load "main.cmo";;
*)
