(* syntaxe abstraite *)
(* fichier syntaxe_abstraite.ml *)

type def =  Edef of (string * expr)

and expr =
   Eint of int
 | Ebool of bool
 | Elocal of string
 | Eglobal of string
 | Eop of op * expr * expr
 | Eapp of expr * expr
 | Eifthenelse of expr * expr * expr
 | Efun of string * expr
 | Elet of string * expr * expr
 | Erec of string * string * expr

and op =
    Eegal       (* =  *)
  | Enegal      (* != *)
  | Einf        (* <  *)
  | Esup        (* >  *)
  | Einf_egal   (* <= *)
  | Esup_egal   (* >= *)
  | Eplus       (* +  *)
  | Emoins      (* -  *)
  | Emult       (* *  *)
  | Ediv        (* /  *)
