(* Calcul des variables libres *)
open Syntaxe_abstraite
let ajout x liees = if List.mem x liees then liees
                    else x :: liees
let rec vars libres liees e =
  match e with
    Eint _ | Ebool _ -> libres
  | Elocal(x) -> if List.mem x liees then libres
                 else ajout x libres
  | Eglobal(x) -> libres
  | Eapp(e1,e2) -> vars (vars libres liees e1) liees e2
  | Eifthenelse(e1,e2,e3) -> 
      vars (vars (vars libres liees e1) liees e2) liees e3
  | Efun(x,e) ->
      let liees = ajout x liees in
      vars libres liees e
  | Elet(x,e1,e2) ->
      let libres1 = vars libres liees e1 in
      let liees = ajout x liees in
      vars libres1 liees e2
  | Erec(f,x,e) ->
      let liees = ajout f (ajout x liees) in
      vars libres liees e
  | Eop(op, e1, e2) ->
      vars (vars libres liees e1) liees e2

let vars e = vars [] [] e
